<?php 
	
	class bluntGA {
		
		private $settings;
		private $option_prefix;
		private $root;
		private $web_path;
		private $errors;
		private $process_error;
		
		public function init() {
			$this->root = dirname(str_replace('\\', '/', str_replace('\\\\', '/', __FILE__)));
			$this->web_path = '/'.str_replace(ABSPATH, '', $this->root);
			$this->errors = array();
			$this->process_error = false;
			$this->getSettings();
			wp_enqueue_script('post');
		} // end public function init
		
		public function activate() {
			$this->defaultSettings();
			$this->getSettings();
			$this->saveSettings();
		} // end public function activate
		
		public function adminMenu() {
			//echo 'here';die;
			$plugin_page = add_options_page('Blunt GA Settings', 
																			'Blunt GA Settings', 
																			'manage_options', 
																			'bluntGA_options_page', 
																			array($this, 'showSettingsForm'));
			add_action('admin_head-'.$plugin_page, array($this, 'adminCSS'));
			
		} // end public function adminMenu
		
		public function showSettingsForm() {
			// if form submitted, process it here with $this->processSettingsForm()
			if (isset($_POST['bluntGA'])) {
				$this->processSettingsForm();
			}
			//echo '<pre>'; print_r($_POST); echo '</pre>';
			?>
				<div class="wrap">
					<h2>Blunt GA Settings</h2>
					<form method="post" action="" id="bluntGAoptionsForm" name="bluntGAoptionsForm" class="bluntGAoptionsForm">
						<?php 
							$action = 'bluntGAoptions_submit';
							$name = 'bluntGA_nonce';
							$referer = true;
							$echo = true;
							wp_nonce_field($action, $name, $referer, $echo);
						?>
						<div id="poststuff">
							<div id="post-body" class="metabox-holder columns-2">
								<div id="post-body-content">
									<?php 
										if (count($this->errors) > 0) {
											// show error messages here
											?>
												<div id="bluntGAerrorMessage">
													<ul>
														<?php 
															foreach ($this->errors as $error) {
																?><li><?php echo $error; ?></li><?php 
															}
														?>
													</ul>
												</div>
											<?php 
										}
									?>
									<div class="postbox">
										<div class="handlediv" title="Click to toggle"><br /></div>
										<h3 class="hndl"><span>Basic Settings</span></h3>
										<div class="inside basic_settings">
											<fieldset>
												<label for="bluntGA_ga_account">
													<span class="label">Google Analyitics Account #: </span>
													<input type="text" name="bluntGA[ga_account]" id="bluntGA_ga_account" value="<?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['ga_account'];
															} else {
																echo $this->settings['ga_account'];
															}
														?>" />
													<span class="notes">Example: UA-12345678-1</span>
												</label><br />
											</fieldset>
											<div class="clear"></div>
										</div>
									</div>
									<div class="postbox"><!-- closed -->
										<div class="handlediv" title="Click to toggle"><br /></div>
										<h3 class="hndl"><span>Outbound Link Tracking</span></h3>
										<div class="inside outbound_settings">
											<fieldset>
												<label for="bluntGA_external_enable">
													<span class="label">Enable Outbound Link Tracking: </span>
													<select name="bluntGA[external][enable]" id="bluntGA_external_enable">
														<?php 
															$options = array(1 => 'Yes', 0 => 'No');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['external']['enable'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['external']['enable'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_external_method">
													<span class="label">Tracking Method: </span>
													<select name="bluntGA[external][method]" id="bluntGA_external_method">
														<?php 
															$options = array('event' => 'Track as Events',
																							 'virtual' => 'Track as Virtual Page Views');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['external']['method'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['external']['method'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_external_category">
													<span class="label">GA Event Category: </span>
													<input type="text" name="bluntGA[external][category]" id="bluntGA_external_category" value="<?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['external']['category'];
															} else {
																echo $this->settings['external']['category'];
															}
														?>" />
												</label><br />
												<label for="bluntGA_external_new_window">
													<span class="label">Open in New Window: </span>
													<select name="bluntGA[external][new_window]" id="bluntGA_external_new_window">
														<?php 
															$options = array(0 => 'No',
																							 1 => 'Yes');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['external']['new_window'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['external']['new_window'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
											</fieldset>
											<div class="clear"></div>
										</div>
									</div>
									<div class="postbox"><!-- closed -->
										<div class="handlediv" title="Click to toggle"><br /></div>
										<h3 class="hndl"><span>Mailto Link Tracking</span></h3>
										<div class="inside mailto_settings">
											<fieldset>
												<label for="bluntGA_mailto_enable">
													<span class="label">Enable Mailto Link Tracking: </span>
													<select name="bluntGA[mailto][enable]" id="bluntGA_mailto_enable">
														<?php 
															$options = array(1 => 'Yes', 0 => 'No');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['mailto']['enable'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['mailto']['enable'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_mailto_method">
													<span class="label">Tracking Method: </span>
													<select name="bluntGA[mailto][method]" id="bluntGA_mailto_method">
														<?php 
															$options = array('event' => 'Track as Events',
																							 'virtual' => 'Track as Virtual Page Views');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['mailto']['method'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['mailto']['method'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_mailto_category">
													<span class="label">GA Event Category: </span>
													<input type="text" name="bluntGA[mailto][category]" id="bluntGA_mailto_category" value="<?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['mailto']['category'];
															} else {
																echo $this->settings['mailto']['category'];
															}
														?>" />
												</label><br />
											</fieldset>
											<div class="clear"></div>
										</div>
									</div>
									<div class="postbox"><!-- closed -->
										<div class="handlediv" title="Click to toggle"><br /></div>
										<h3 class="hndl"><span>Document/File Link Tracking</span></h3>
										<div class="inside document_settings">
											<fieldset>
												<label for="bluntGA_document_enable">
													<span class="label">Enable Document/File Link Tracking: </span>
													<select name="bluntGA[document][enable]" id="bluntGA_document_enable">
														<?php 
															$options = array(1 => 'Yes', 0 => 'No');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['document']['enable'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['document']['enable'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_document_method">
													<span class="label">Tracking Method: </span>
													<select name="bluntGA[document][method]" id="bluntGA_document_method">
														<?php 
															$options = array('event' => 'Track as Events',
																							 'virtual' => 'Track as Virtual Page Views');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['document']['method'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['document']['method'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_document_category">
													<span class="label">GA Event Category: </span>
													<input type="text" name="bluntGA[document][category]" id="bluntGA_document_category" value="<?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['document']['category'];
															} else {
																echo $this->settings['document']['category'];
															}
														?>" />
												</label><br />
												<label for="bluntGA_document_new_window">
													<span class="label">Open in New Window: </span>
													<select name="bluntGA[document][new_window]" id="bluntGA_document_new_window">
														<?php 
															$options = array(0 => 'No',
																							 1 => 'Yes');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['document']['new_window'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['document']['new_window'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_document_extensions">
													<span class="label">Document Extensions to Track: </span>
													<input type="text" name="bluntGA[document][extensions]" id="bluntGA_document_extensions" value="<?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['document']['extensions'];
															} else {
																$value = implode(', ', $this->settings['document']['extensions']);
																echo $value;
															}
														?>" class="wide" />
												</label><br />
											</fieldset>
											<div class="clear"></div>
										</div>
									</div>
									<div class="postbox"><!-- closed -->
										<div class="handlediv" title="Click to toggle"><br /></div>
										<h3 class="hndl"><span>Anchor Link Tracking</span></h3>
										<div class="inside anchors_settings">
											<fieldset>
												<label for="bluntGA_anchors_enable">
													<span class="label">Enable Anchor Link Tracking: </span>
													<select name="bluntGA[anchors][enable]" id="bluntGA_anchors_enable">
														<?php 
															$options = array(1 => 'Yes', 0 => 'No');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['anchors']['enable'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['anchors']['enable'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_anchors_method">
													<span class="label">Tracking Method: </span>
													<select name="bluntGA[anchors][method]" id="bluntGA_anchors_method">
														<?php 
															$options = array('event' => 'Track as Events',
																							 'virtual' => 'Track as Virtual Page Views');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['anchors']['method'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['anchors']['method'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_anchors_category">
													<span class="label">GA Event Category: </span>
													<input type="text" name="bluntGA[anchors][category]" id="bluntGA_anchors_category" value="<?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['anchors']['category'];
															} else {
																echo $this->settings['anchors']['category'];
															}
														?>" />
												</label><br />
											</fieldset>
											<div class="clear"></div>
										</div>
									</div>
									<div class="postbox"><!-- closed -->
										<div class="handlediv" title="Click to toggle"><br /></div>
										<h3 class="hndl"><span>Form Submission Tracking</span></h3>
										<div class="inside form_settings">
											<fieldset>
												<label for="bluntGA_form_enable">
													<span class="label">Enable Form Submission Tracking: </span>
													<select name="bluntGA[form][enable]" id="bluntGA_form_enable">
														<?php 
															$options = array(1 => 'Yes', 0 => 'No');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['form']['enable'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['form']['enable'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_form_method">
													<span class="label">Tracking Method: </span>
													<select name="bluntGA[form][method]" id="bluntGA_form_method">
														<?php 
															$options = array('event' => 'Track as Events',
																							 'virtual' => 'Track as Virtual Page Views');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['form']['method'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['form']['method'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_form_category">
													<span class="label">GA Event Category: </span>
													<input type="text" name="bluntGA[form][category]" id="bluntGA_form_category" value="<?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['form']['category'];
															} else {
																echo $this->settings['form']['category'];
															}
														?>" />
												</label><br />
											</fieldset>
											<div class="clear"></div>
										</div>
									</div>
									<div class="postbox"><!-- closed -->
										<div class="handlediv" title="Click to toggle"><br /></div>
										<h3 class="hndl"><span>Conversion Tracking</span></h3>
										<div class="inside conversions_settings">
											<fieldset>
												<label for="bluntGA_conversions_enable">
													<span class="label">Enable Conversion Tracking: </span>
													<select name="bluntGA[conversions][enable]" id="bluntGA_conversions_enable">
														<?php 
															$options = array(1 => 'Yes', 0 => 'No');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['conversions']['enable'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['conversions']['enable'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_conversions_method">
													<span class="label">Tracking Method: </span>
													<select name="bluntGA[conversions][method]" id="bluntGA_conversions_method">
														<?php 
															$options = array('event' => 'Track as Events',
																							 'virtual' => 'Track as Virtual Page Views');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['conversions']['method'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['conversions']['method'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_conversions_category">
													<span class="label">GA Event Category: </span>
													<input type="text" name="bluntGA[conversions][category]" id="bluntGA_conversions_category" value="<?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['conversions']['category'];
															} else {
																echo $this->settings['conversions']['category'];
															}
														?>" />
												</label><br />
												<label for="bluntGA_conversions_pages">
													<span class="label">Conversion Pages: </span>
													<textarea name="bluntGA[conversions][pages]" id="bluntGA_conversions_pages" cols="40" rows="5" class="list1"><?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['conversions']['pages'];
															} else {
																$value = implode("\r\n", $this->settings['conversions']['pages']);
																echo $value;
															}
														?></textarea>
												</label><br />
											</fieldset>
											<div class="clear"></div>
										</div>
									</div>
									<div class="postbox"><!-- closed -->
										<div class="handlediv" title="Click to toggle"><br /></div>
										<h3 class="hndl"><span>Cross Site Tracking</span></h3>
										<div class="inside cross_site_settings">
											<fieldset>
												<label for="bluntGA_cross_site_enable">
													<span class="label">Enable Cross Site Tracking: </span>
													<select name="bluntGA[cross_site][enable]" id="bluntGA_cross_site_enable">
														<?php 
															$options = array(1 => 'Yes', 0 => 'No');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['cross_site']['enable'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['cross_site']['enable'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_cross_site_domain">
													<span class="label">Cross Site Domain: </span>
													<input type="text" name="bluntGA[cross_site][domain]" id="bluntGA_cross_site_domain" value="<?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['cross_site']['domain'];
															} else {
																echo $this->settings['cross_site']['domain'];
															}
														?>" class="wide" />
												</label><br />
												<label for="bluntGA_cross_site_prefix">
													<span class="label">Cross Site Prefix: </span>
													<input type="text" name="bluntGA[cross_site][prefix]" id="bluntGA_cross_site_prefix" value="<?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['cross_site']['prefix'];
															} else {
																echo $this->settings['cross_site']['prefix'];
															}
														?>" />
												</label><br />
												<label for="bluntGA_cross_link_enable">
													<span class="label">Enable Cross Site Linking: </span>
													<select name="bluntGA[cross_link][enable]" id="bluntGA_cross_link_enable">
														<?php 
															$options = array(1 => 'Yes', 0 => 'No');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['cross_link']['enable'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['cross_link']['enable'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_cross_link_event">
													<span class="label">Enable Cross Site Linking Events: </span>
													<select name="bluntGA[cross_link][event]" id="bluntGA_cross_link_event">
														<?php 
															$options = array(1 => 'Yes', 0 => 'No');
															foreach ($options as $value => $label) {
																$selected = false;
																if (isset($_POST['bluntGA']) && $_POST['bluntGA']['cross_link']['event'] == $value) {
																	$selected = true;
																} elseif (!isset($_POST['bluntGA']) && $this->settings['cross_link']['event'] == $value) {
																	$selected = true;
																}
																?>
																	<option value="<?php echo $value; ?>"<?php 
																			if ($selected) {
																				?> selected="selected"<?php 
																			}
																		?>><?php echo $label; ?></option>
																<?php 
															} // end foreach option
														?>
													</select>
												</label><br />
												<label for="bluntGA_cross_link_domains">
													<span class="label">Cross Linked Domains: </span>
													<textarea name="bluntGA[cross_link][domains]" id="bluntGA_cross_link_domains" cols="40" rows="5" class="list2"><?php 
															if (isset($_POST['bluntGA'])) {
																echo $_POST['bluntGA']['cross_link']['domains'];
															} else {
																$value = implode("\r\n", $this->settings['cross_link']['domains']);
																echo $value;
															}
														?></textarea>
												</label><br />
											</fieldset>
											<div class="clear"></div>
										</div>
									</div>
									<input type="submit" name="bluntGAsubmit" value="Save Changes" class="button" />
								</div>
								<div id="postbox-container-1" class="postbox-container"></div>
							</div>
						</div>
					</form>
				</div>
			<?php 
		} // end public function showSettingsForm
		
		public function processSettingsForm() {
			/*
							$action = 'bluntGAoptions_submit';
							$name = 'bluntGA_nonce';
							$referer = true;
							$echo = true;
							wp_nonce_field($action, $name, $referer, $echo);
			*/
			$nonce = $_POST['bluntGA_nonce'];
			if (!wp_verify_nonce($nonce, 'bluntGAoptions_submit') ||
					$_POST['_wp_http_referer'] != $_SERVER['REQUEST_URI']) {
				$this->errors['security'] = 'Invalid Security Check';
				return;
			}
			
			
			$section_text = array('anchors' => 'Anchor Link Tracking',
														'external' => 'Outbound Link Tracking',
														'mailto' => 'Mailto Link Tracking',
														'document' => 'Document/File Link Tracking',
														'form' => 'Form Submission Tracking',
														'cross_site' => 'Cross Site Tracking',
														'cross_link' => 'Cross Site Linking',
														'conversions' => 'Conversion Tracking');
			
			foreach ($_POST['bluntGA'] as $section => $options) {
				if (!is_array($options)) {
					$error = false;
					$setting = $section;
					$value = trim($options);
					switch ($setting) {
						case 'ga_account':
							// check for valid ga account?
							// can be empty, basically turns off ga tracking
							if ($value != '') {
								if (!preg_match('/^UA-[0-9]{4,12}-[0-9]{1,4}$/', $value)) {
									// invalid GA #
									$message = 'The Google Analytics Account # Entered Does Not Appear to be Valid.';
									$this->errors[$setting] = $message;
									$this->process_error = true;
									$error = true;
								}
							} else {
								// warning, tracking off without a valid GA #
								$message = 'Warning: No Google Analytics Account # Given. Tracking Was Not Enabled.';
								$this->errors[$setting] = $message;
							}
							if (!$error) {
								$this->settings[$setting] = $value;
							}
							break;
						default:
							// do nothing
							break;
					}
				} else {
					foreach ($options as $setting => $value) {
						$error = false;
						switch ($setting) {
							case 'enable':
							case 'new_window':
							case 'non_interact':
							case 'event':
								// true/false
								if ($value == 1) {
									$value = true;
								} else {
									$value = false;
								}
								// if this is enabling cross site linking then cross site tracking must also be enabled
								if ($section == 'cross_link' && !$_POST['bluntGA']['cross_site']['enable'] && $value) {
									// cross linking enabled but cross site not
									$message = 'You must enable '.$section_text['cross site'].' to enable '.$setting_text[$section].'.';
									$this->errors[$section.'_'.$setting] = $message;
									$this->process_error = true;
									$error = true;
								}
								if (!$error) {
									$this->settings[$section][$setting] = $value;
								}
								break;								
							case 'method':
								// event/virtual
								if ($value != 'virtual') {
									$value = 'event';
								}
								$this->settings[$section][$setting] = $value;
								break;								
							case 'category':
								// text value, required if section is enabled
								// only allows letters, numbers, hyphen and underscore
								$value = trim($value);
								if ($value != '') {
									if (preg_match('/[^-_.a-z0-9]/i', $value)) {
										$message = '';
										$message .= 'GA Event Category for '.$section_text[$section].' Contains Invalid Characters.<br />';
										$message .= 'This field may only contain letters, numbers, _ (underscore), - (hyphen) and . (dot).';
										$this->errors[$section.'_'.$setting] = $message;
										$this->process_error = true;
										$error = true;
									}
								} else {
									// value is empty, required if section is enabled
									if ($_POST['bluntGA'][$section]['enable']) {
										$this->errors[$section.'_'.$setting] = 'GA Event Category is Required to Enable '.$section_text[$section];
										$this->process_error = true;
										$error = true;
									}
								}
								if (!$error) {
									$this->settings[$section][$setting] = $value;
								}
								break;
							case 'prefix':
							case 'suffix':
								// text value, not required
								// only allows letters, numbers, hyphen and underscore, dot
								$value = trim(trim($value), '/');
								if ($value != '') {
									if (preg_match('/[^-_.a-z0-9]/i', $value)) {
										$message = '';
										$message .= $section_text[$section].' '.ucwords($setting).' Contains Invalid Characters.<br />';
										$message .= 'This field may only contain letters, numbers, _ (underscore), - (hyphen) and . (dot).';
										$this->errors[$section.'_'.$setting] = $message;
										$this->process_error = true;
										$error = true;
									}
								}
								if (!$error) {
									$this->settings[$section][$setting] = $value;
								}
								break;
							case 'extensions':
								// extention list
								// comma seperated list (?? , ; :), . is optional and removed
								// allows letters, numbers, underscore, hyphen, dot
								// does not allow valid web page extensions
								// requires at least one extension if document tracking enabled
								$extensions = preg_split('/\s*[,;]\s*\.*/', $value);
								foreach ($extensions as $index => $extension) {
									if ($extension == '') {
										unset($extensions[$index]);
									} else {
										if (preg_match('/[^-_.a-z0-9]/i', $extension)) {
											$message = 'Invalid Extension in Document Extensions List.';
											$this->errors[$section.'_'.$setting] = $message;
											$this->process_error = true;
											$error = true;
										}
									}
								} // end foreach extension
								$extensions = array_values($extensions);
								$_POST['bluntGA'][$section][$setting] = implode(', ', $extensions); 
								if (count($extensions) == 0) {
									if ($_POST['bluntGA'][$section]['enable']) {
										// document tracking enabled but no extensions given
										$message = 'At Least One Document Extension is Required to Enable '.$section_text[$section];
										$this->errors[$section.'_'.$setting] = $message;
										$this->process_error = true;
										$error = true;
									}
								}
								if (!$error) {
									$this->settings[$section][$setting] = $extensions;
								}
								break;
							case 'delay':
								// dealy time
								$value = floatval($value);
								$this->settings[$section][$setting] = $value;
								break;
							case 'pages':
								// list of local pages, one per line
								// requires at least one if conversion tracking is enabled
								$pages = $this->splitList($value);
								if (count($pages) > 0) {
									$pages = preg_replace('#^(https?://)?'.preg_quote($_SERVER['HTTP_HOST']).'#i', '', $pages);
									$_POST['bluntGA'][$section][$option] = implode("\r\n", $pages);
									foreach ($pages as $page) {
										if (preg_match('#^https?://#', $page)) {
											$message = 'Conversion Pages For '.$section_text[$section].' May Only Contain Pages On This Domain.';
											$this->errors[$section.'_'.$setting] = $message;
											$this->process_error = true;
											$error = true;
											break;
										} elseif (!preg_match('#^/#', $page)) {
											$message = 'Conversion Pages For '.$section_text[$section].' Must Be Absolute From Site Root (start with a slash /).';
											$this->errors[$section.'_'.$setting] = $message;
											$this->process_error = true;
											$error = true;
											break;
										}
									} // end foreach page
								} else {
									if ($_POST['bluntGA'][$section]['enable']) {
										// enabled but no conversion pages given
										$message = 'You Must Specify At Lease One Conversion Page to Enable '.$section_text[$section].'.';
										$this->errors[$section.'_'.$setting] = $message;
										$this->process_error = true;
										$error = true;
									}
								}
								if (!$error) {
									$this->settings[$section][$setting] = $pages;
								}
								break;
							case 'domain':
								// single domain name, connont be this domain
								// required if cross site tracking is enabled
								$value = preg_replace('#^((https?:/)?/)?([^/]*)(/.*)?$#i', '\3', trim($value));
								if ($value == '') {
									// no domain given, check enable, required to enable
									if ($_POST['bluntGA']['cross_site']['enable']) {
										$message = 'No Domain Given for '.$section_text[$section].'.';
										$this->errors[$section.'_'.$setting] = $message;
										$this->process_error = true;
										$error = true;
									}
								} else {
									// domain given, check it is a valid looking domain name
									// and that it is not this domain name
									if ($value == $_SERVER['HTTP_HOST']) {
										// cannot specify this domain
										$message = 'The Domain Entered for '.$section_text[$section].' is This Domain.<br />';
										$message .= 'You must enter a different domain to enable '.$section_text[$section].'.';
										$this->errors[$section.'_'.$setting] = $message;
										$this->process_error = true;
										$error = true;
									} elseif (!$this->isValidDomain($value)) {
										// invalid domain name
										$message = 'The Domain Entered for '.$section_text[$section].' Does Not Appear to be Valid.';
										$this->errors[$section.'_'.$setting] = $message;
										$this->process_error = true;
										$error = true;
									}
								}
								$_POST['bluntGA']['cross_site']['domain'] = $value;
								if (!$error) {
									$this->settings[$section][$setting] = $value;
								}
								break;
							case 'domains':
								// list of domains
								// requires at least one if cross site linking is enabled
								// the domain given in cross site tracking must be included
								$domains = $this->splitList($value);
								$domains = preg_replace('#^((https?:/)?/)?([^/]*)(/.*)?$#i', '\3', $domains);
								if ($_POST['bluntGA']['cross_site']['domain'] != '' &&
										!in_array($_POST['bluntGA']['cross_site']['domain'], $domains) &&
										$_POST['bluntGA']['cross_site']['domain'] != $_SERVER['HTTP_HOST']) {
									$domains[] = $_POST['bluntGA']['cross_site']['domain'];
								}
								if (count($domains) > 0) {
									foreach ($domains as $domain) {
										if (!$this->isValidDomain($domain)) {
											// invalid domain name
											$message = 'A Domain Entered for '.$section_text[$section].' Does Not Appear to be Valid.';
											$this->errors[$section.'_'.$setting] = $message;
											$this->process_error = true;
											$error = true;
											break;
										}
									} // end foreach domain
								} else {
									// no domain given for cross site linking
									// if enabled then there must be at least one
									if ($_POST['bluntGA']['cross_link']['enable']) {
										$message = 'No Domains Entered for '.$section_text[$section].'.<br />';
										$message .= 'You must enter at least one valid domain to enable '.$section_text[$section].'.';
										$this->errors[$section.'_'.$setting] = $message;
										$this->process_error = true;
										$error = true;
										break;
									}
								}
								if (!$error) {
									$this->settings[$section][$setting] = $domains;
								}
								break;
							default:
								// do nothing
								break;
						} // end switch $setting
					} // end foreach $options
				} // end if array else
			} // end foreach $_POST['bluntGA']
			
			// if no processing errors occur
			// save new settings and clear posted values
			// set error message to display successful save
			if (!$this->process_error) {
				$this->errors['success'] = 'All Settings Saved.';
				$this->saveSettings();
				$_POST = array();
			}
		} // end public function processChanges
		
		private function isValidDomain($value) {
			$valid = true;
			if ((!preg_match('/^[-0-9a-z]+(\.[-0-9a-z]+)+$/i', $value) && 
					 !preg_match('/^[0-9]+(\.[0-9]+){3}$/', $value)) || 
					strlen($value) > 64) {
				$valid = false;
			}
			return $valid;
		} // end private function isValidDomain
		
		public function outputScripts() {
			$bluntGA_options = str_replace('+', '%20', urlencode('('.json_encode($this->settings).')'));
			?>
				<script type="text/javascript">
					var bluntGA_options = '<?php echo $bluntGA_options; ?>';
				</script>
				<script type="text/javascript" src="<?php echo $this->web_path; ?>/blunt.ga.install.v3.js.php"></script>
			<?php 
		} // end public function output
		
		public function adminCSS() {
			?>
				<link rel="stylesheet" type="text/css" href="<?php echo $this->web_path; ?>/admin.css" />
			<?php 
		} // end public function adminCSS
		
		private function splitList($value) {
			$value = trim($value);
			//$value = preg_replace('/\s*[,]\s*/', '\n', $value);
			$value = str_replace("\r", "\n", $value);
			$value = preg_replace('/\n+/', "\n", $value);
			$array = preg_split('/\s*\n\s*/', $value);
			foreach ($array as $index => $value) {
				if ($value == '') {
					unset($array[$index]);
				}
			}
			$array = array_values($array);
			return $array;
		} // end private function splitList
		
		private function defaultSettings() {
			$this->settings = array('ga_account' => '',
															'anchors' => array('enable' => false,   // links to # on same page
																								 'method' => 'event',  // valid values are event and virtual (virtual == virtual page view)
																								 'category' => 'anchor_click',
																								 'non_interact' => false,
																								 'new_window' => false,
																								 'delay' => 0.0),
															'external' => array('enable' => false,
																									'method' => 'event',
																									'category' => 'link_outbound',
																									'non_interact' => true,
																									'new_window' => true,
																									'delay' => 0.1),
															'mailto' => array('enable' => false,
																								'method' => 'event',
																								'category' => 'link_mailto',
																								'non_interact' => false,
																								'new_window' => false,
																								'delay' => 0.1),
															'document' => array('enable' => false,
																									'method' => 'event',
																									'category' => 'link_document',
																									'non_interact' => false,
																									'new_window' => true,
																									'delay' => 0.1,
																									'extensions' => array('pdf',
																																				'doc',
																																				'docx',
																																				'xls',
																																				'csv',
																																				'jpg',
																																				'gif',
																																				'mp3',
																																				'swf',
																																				'txt',
																																				'ppt',
																																				'zip',
																																				'gz',
																																				'dmg',
																																				'xml')),
															'form' => array('enable' => false,
																							'method' => 'event',
																							'category' => 'form_submit',
																							'non_interact' => false,
																							'delay' => 0.1),
															'cross_site' => array('enable' => false,
																										'domain' => '',
																										'prefix' => '',
																										'sufix' => ''),
															'cross_link' => array('enable' => false,
																										'event' => false,
																										'domains' => array()),
															'conversions' => array('enable' => false,				// pages for conversions must be abs from doc root
																										 'method' => 'event',
																										 'category' => 'form_conversion',
																										 'non_interact' => false,
																										 'pages' => array()),
															'sharethis' => array('enable' => false,
																									 'switchTo5x' => true,
																									 'publisher_id' => ''));
		} // end private function defaultSettings
		
		private function saveSettings() {
			$settings = json_encode($this->settings);
			$option = 'bluntGA_settings';
			update_option($option, $settings);
		} // end private fuction saveSettings
		
		private function getSettings() {
			$option = 'bluntGA_settings';
			if (($settings = get_option($option, false)) !== false) {
				$this->settings = json_decode($settings, true);
			}
		} // end private function getSettings
		
	} // end class bluntGA
	
?>